#!/usr/bin/python
# -*- coding: utf-8 -*-

from time import sleep
import sys
import datetime
import time
import os
import rrdtool


dbname = '1wire'
rrd_root  = "/var/www/1wire/"
rrd_graph_root = "/var/www/1wire/"
log_rrd = True


sensor_list = []
sensor_locations = []
sensor_dict = {}

dead_max = 80
dead_hi = -0.02
dead_lo = -0.08
error_temp = -999

verbose_level = 1
read_sens = 1

def LogToRRD (rrdKey, rrdValue, rrdDevice, graphLabel, graphColour):
        if not os.path.exists(rrd_root + rrdDevice + ".rrd"):
                print "Erzeuge Datenbank\n"
                ret = rrdtool.create(rrd_root + rrdDevice + ".rrd", "--step", "60",
                "DS:" + rrdKey + ":GAUGE:120:-273:5000",
                "RRA:AVERAGE:0.5:1:1200",
                "RRA:MIN:0.5:12:2400",
                "RRA:MAX:0.5:12:2400",
                "RRA:AVERAGE:0.5:12:2400")
        print (rrdValue)
        ret = rrdtool.update(rrd_root + rrdDevice + ".rrd", 'N:' + str(rrdValue));
        ret = rrdtool.graph(rrd_graph_root + rrdDevice + "_stunde.png", "--start", "-4h", "--title=" + rrdDevice.title() + " Letzte Stunde",
        '--watermark=zentis.dyndns.org',
        "-w 800",
        "--alt-autoscale",
        "DEF:" + rrdKey + "=" + rrd_root + rrdDevice + ".rrd:" + rrdKey + ":AVERAGE",
        "LINE1:" + rrdKey + graphColour + ":" + rrdKey + " " + graphLabel)

        ret = rrdtool.graph(rrd_graph_root + rrdDevice + "_tag.png", "--start", "-4d", "--title=" + rrdDevice.title() + " Diesen Tag",
        '--watermark=zentis.dyndns.org',
        "-w 800",
        "--alt-autoscale",
        "DEF:" + rrdKey + "=" + rrd_root + rrdDevice + ".rrd:" + rrdKey + ":AVERAGE",
        "LINE1:" + rrdKey + graphColour + ":" + rrdKey + " " + graphLabel)

        ret = rrdtool.graph(rrd_graph_root + rrdDevice + "_monat.png", "--start", "-1m", "--title=" + rrdDevice.title() + " Diesen Monat",
        '--watermark=zentis.dyndns.org',
        "-w 800",
        "--alt-autoscale",
        "DEF:" + rrdKey + "=" + rrd_root + rrdDevice + ".rrd:" + rrdKey + ":AVERAGE",
        "LINE1:" + rrdKey + graphColour + ":" + rrdKey + " " +  graphLabel)


def read_sensor(sensor_slave):

        sensor_device = '/sys/bus/w1/devices/' + str(sensor_slave) + '/w1_slave'
        try:
                file = open(sensor_device)
                filecontent = file.read()
                file.close()
                stringvalue = filecontent.split("\n")[1].split(" ")[9]
                if stringvalue[0].find("YES") > 0:
                        temp = error_temp
                else:
                        temp = float(stringvalue[2:]) / 1000
        except IOError:
                print "PANIC read_sensor - Cannot find file &gt;" + sensor_slave + " cat /sys/devices/w1_bus_master1/w1_master_slaves"
                sys.exit(1)
#
        return(temp)
while (True):

        sensor_count = 0
        sensor_slaves = '/sys/devices/w1_bus_master1/w1_master_slaves'
        file = open(sensor_slaves)
        w1_slaves = file.readlines()
        file.close()
        print('Sensor ID       | Temperature')
        print('-----------------------------')
        
        for line in w1_slaves:
                w1_slave = line.split("\n")[0]
                #time.sleep(0.2)
                temperature = read_sensor( w1_slave)
                
        if log_rrd == True:
                LogToRRD("Temperature",temperature,"temp", "[deg C]", "#CC0000")
                